quadrat <- function( parm ){
# Test case for hess

# Returns quadratic function
#   t(parm) %*% coef2 %*% parm + coef1 * parm + coef0
# where coef2 is a square matrix: length(parm) x length(parm)
#       coef1 is a vector of length length(parm)
#       coef0 is a scalar

# coef2, coef1, coef0 must be available globally since hess assumes
# a function with only one argument

# the hessian should be t(coef2) + coef2 regardless of the other
# parameters

lparm <- length(parm)

parm <- matrix( parm, nrow=lparm, ncol=1 )


answer <- t(parm) %*% coef2 %*% parm + coef1 %*% parm + coef0

return( answer )     }

coef2 <- matrix( 1:9, nrow=3, ncol=3 )

coef1 <- rep( 1, 3 )

coef0 <- 1

# print out true answer

cat(' The hessian should be: \n' )

print( t(coef2) + coef2 )

# evaluate the hessian at zero

cat(' Evaluating the hessian at all parameters 0: \n' )

parm <- rep( 0, 3 )

print( hessian( quadrat,  parm ) )

# evaluate the hessian at ten

cat(' Evaluating the hessian at all parameters 10: \n' )

parm <- rep( 10, 3 )

print( hessian( quadrat,  parm ) )

# evaluate the hessian at 100

cat(' Evaluating the hessian at all parameters 100: \n' )

parm <- rep( 100, 3 )

print( hessian( quadrat,  parm ) )
